// on importe la bibliotheque opencv
import hypermedia.video.*;
import java.awt.*;

// on créée un objet opencv
OpenCV opencv;

// on créée une variable pour initiliser la valeur de contraste de l'image en bas à droite
int threshold = 80;

// on crée une variable booléenne
boolean find=true;

void setup() {
  // on détermine la taille de notre sketch
  size( 800, 600 );

  // on initialise l'objet OpenCV
  opencv = new OpenCV( this );
  // on créée la fenêtre de capture de la largeur et la hauteur de notre sketch
  opencv.capture(width, height);
}



void draw() {
  //je lance la lecture de ce que capte la camera
  opencv.read();
  // je desactive la fonction mirroir d'affichage
  //opencv.flip( OpenCV.FLIP_HORIZONTAL );

  // ma fenêtre de capture en haut à gauche (poisition X : 10, position Y : 10)
  image( opencv.image(), 0, 0 );

  //opencv.absDiff();
  //j'active la fonction de contraste et lui attribue la valeur de la variable 'treshold'
  opencv.threshold(threshold);


  // on lance la detection de blobs sous forme de liste.
  // les paramètres de opencv.blobs()
  Blob[] blobs = opencv.blobs( 100, width*height/3, 20, true );

  // on desactive le remplissage de toutes les formes qui vont suivre dans le programme
  noFill();

  pushMatrix();

  //on créée un boucle d'itération pour détecter de manière 
  //dynamique TOUTES les surafces les plus claires 
  //de la captation de la webcam
  for ( int i=0; i<blobs.length; i++ ) {

    // à chaque blobs, on active la fonction .centroid
    // de la bibliothèque OpenCV
    //ça va nous permettre de récupérer les positions X et Y
    // des centres de gravité de nos blobs
    Point centroid = blobs[i].centroid;

    //on dessine un contour en demandant à la bibliothèque opencv
    // par la fonction .isHole : on s'assure que c'est ou non un blob dans un autre blob
    stroke( blobs[i].isHole ? 128 : 64 );


    // CENTROID / CENTRES DE GRAVITÉ
    noStroke();
    //on active une nouvelle couleur de remplissage
    fill(255, 0, 0);
    //on dessine notre cercle en prenant les coordonnées de nos centres de gravités
    // comme coordonnées des centres de nos cercles
    ellipse(centroid.x, centroid.y, 10, 10);
  }
  popMatrix();
}

//FONCTION RÉGLAGE DE CONTRASTE GRACE A NOTRE CURSEUR DE SOURIS

void mouseDragged() {
  // quand on déplace la souris, on change la valeur du contraste 
  threshold = int( map(mouseX, 0, width, 0, 255) );
}

public void stop() {
  // une fonction qui arrête tous les processus en cours lors de l'extinction de notre sketch
  opencv.stop();
  super.stop();
}

